function [sol, traj] = bisec_rk(func, a, b, tol)
    if func(a)*func(b) >= 0
        error('The function must have opposite signs at a and b.');
    end

    traj = [];  % initialize trajectory vector

    while (b - a)/2 > tol
        c = (a + b) / 2;
        traj(end+1) = c; 
        if abs(func(c)) < tol
            sol = c;
            return; % exact solution found
        elseif func(a)*func(c) < 0
            b = c;
        else
            a = c;
        end
    end
    sol = (a + b) / 2;
    traj(end+1) = sol;
end