function [sol, traj] = newton_rk(func, dfunc, x0, tol)
    traj = x0;  % record the initial guess

    while abs(func(x0)) > tol
        dfx = dfunc(x0);
        if dfx == 0
            error('Zero derivative encountered in Newton''s method.');
        end
        x0 = x0 - func(x0)/dfx;
        traj(end+1) = x0; 
    end

    sol = x0;
end